$SAFE = 2
$CUR = '%0.2f'

# ***** Code Fixes *****
# Overrides some methods in the base class String.
class String
	alias orig_to_f to_f
	alias orig_to_i to_i
	alias string_format %
	def to_f
		delete(',').orig_to_f
	end
	def to_i
		delete(',').orig_to_i
	end
	def %(arg)
		if (arg.kind_of?(Array) or index('f') == nil)
			string_format(arg)
		else
			value = arg.to_f
			string_format(value < 0.0 ? value - 0.00000001 : value + 0.00000001)
		end
	end

end

# ***** Profile Classes *****
class Individual
 def first_name; ''; end
 def middle_initial; ''; end
 def last_name; ''; end
 def suffix; ''; end
 def address; ''; end
 def apartment_number; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def work_phone; ''; end
 def mobile_phone; ''; end
 def fax; ''; end
 def ssn; ''; end
 def occupation; ''; end
 def county; ''; end
 def school_code; ''; end
 def email; ''; end
 def blind; ''; end
 def sixty_five_plus; ''; end
 def spouse_first_name; ''; end
 def spouse_middle_initial; ''; end
 def spouse_last_name; ''; end
 def spouse_suffix; ''; end
 def spouse_address; ''; end
 def spouse_apartment_number; ''; end
 def spouse_city; ''; end
 def spouse_state; ''; end
 def spouse_zip; ''; end
 def spouse_phone; ''; end
 def spouse_work_phone; ''; end
 def spouse_mobile_phone; ''; end
 def spouse_fax; ''; end
 def spouse_ssn; ''; end
 def spouse_occupation; ''; end
 def spouse_county; ''; end
 def spouse_school_code; ''; end
 def spouse_email; ''; end
 def spouse_blind; ''; end
 def spouse_65_plus; ''; end
 def single; ''; end
 def married_joint; ''; end
 def married_separate; ''; end
 def head_of_household; ''; end
 def widow_widower; ''; end
 def direct_deposit_checking; ''; end
 def direct_deposit_savings; ''; end
 def routing_number; ''; end
 def account_number; ''; end
 def dependent1_first_name; ''; end
 def dependent1_last_name; ''; end
 def dependent1_ssn; ''; end
 def dependent1_relationship; ''; end
 def dependent1_dob; ''; end
 def dependent2_first_name; ''; end
 def dependent2_last_name; ''; end
 def dependent2_ssn; ''; end
 def dependent2_relationship; ''; end
 def dependent2_dob; ''; end
 def dependent3_first_name; ''; end
 def dependent3_last_name; ''; end
 def dependent3_ssn; ''; end
 def dependent3_relationship; ''; end
 def dependent3_dob; ''; end
 def dependent4_first_name; ''; end
 def dependent4_last_name; ''; end
 def dependent4_ssn; ''; end
 def dependent4_relationship; ''; end
 def dependent4_dob; ''; end
 def dependent5_first_name; ''; end
 def dependent5_last_name; ''; end
 def dependent5_ssn; ''; end
 def dependent5_relationship; ''; end
 def dependent5_dob; ''; end
 def dependent6_first_name; ''; end
 def dependent6_last_name; ''; end
 def dependent6_ssn; ''; end
 def dependent6_relationship; ''; end
 def dependent6_dob; ''; end
 def business_name; ''; end
 def business_address; ''; end
 def business_address2; ''; end
 def business_city; ''; end
 def business_state; ''; end
 def business_zip; ''; end
 def fein; ''; end
 def business_phone; ''; end
 def business_fax; ''; end
 def business_email; ''; end
end

class Entity
 def name; ''; end
 def address; ''; end
 def address2; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def fax; ''; end
 def email; ''; end
 def fein; ''; end
 def state_id; ''; end
 def date_started; ''; end
 def state_of_incorporation; ''; end
 def naics_code; ''; end
 def principal_activity; ''; end
 def contact_name; ''; end
 def contact_title; ''; end
 def contact_phone; ''; end
 def estate_name; ''; end
 def estate_ssn; ''; end
 def estate_dod; ''; end
 def agent_first_name; ''; end
 def agent_middle_initial; ''; end
 def agent_last_name; ''; end
 def agent_business_name; ''; end
 def agent_address; ''; end
 def agent_city; ''; end
 def agent_state; ''; end
 def agent_zip; ''; end
 def agent_phone; ''; end
end

class Preparer
 def first_name; ''; end
 def middle_initial; ''; end
 def last_name; ''; end
 def firm_name; ''; end
 def address; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def work_phone; ''; end
 def mobile_phone; ''; end
 def fax; ''; end
 def email; ''; end
 def fein; ''; end
 def ptin; ''; end
 def ssn; ''; end
 def self_employed; ''; end
end

# ***** Field Data *****
# ***** Calculations *****
$,="\x02"
$\="\x03\n"
$MAX_CID_CHECK = 1
require 'Win32API'

if (defined?(cid1_1)).nil? == true
	if( box1_65535.to_i == $MAX_CID_CHECK - 1 )
		mb = Win32API.new("user32", "MessageBox", ['L', 'P', 'P', 'L'], 'L')
		mb.Call(0, 'This document will not function properly in this version of the forms software. Please close this document without saving and update the software.', 'New Software Available', 40000)
	end

	box1_65535 = ((box1_65535.to_i + 1) % $MAX_CID_CHECK).to_s
	print "box1_65535", box1_65535
	cid1_1 = ''
end

if (defined?(cid16_1)).nil? == true
	cid16_1 = ''
else
	print "cid16_1", cid16_1
end

# ***** End Company Identifier Calculations *****
#
# DATAFLOW: for name fields shown with 2 boxes: dataflow 1st box with taxpayers first name, dataflow 2nd box with last name.
# Per DAS, this also applies to posting to subsequent page headings with 2 boxes -even if those headings say 'name(s)'.

individual = Individual.new
preparer = Preparer.new
entity = Entity.new

tmp = individual.ssn.strip
print 'box2_1', tmp if !tmp.empty?

tmp = individual.spouse_ssn.strip
print 'box2_2', tmp if !tmp.empty?

# 12/11/18 [jgluszek]: do not truncate name fields per WorkFlow Note.
tmp = individual.first_name.strip
print 'box2_4', tmp if !tmp.empty?

tmp = individual.middle_initial.strip
print 'box2_5', tmp if !tmp.empty?

tmp = individual.last_name.strip
print 'box2_6', tmp if !tmp.empty?

tmp = individual.suffix.strip
print 'box2_72', tmp if !tmp.empty?

tmp = individual.spouse_first_name.strip
print 'box2_7', tmp if !tmp.empty?

tmp = individual.spouse_middle_initial.strip
print 'box2_8', tmp if !tmp.empty?

tmp = individual.spouse_last_name.strip
print 'box2_9', tmp if !tmp.empty?

tmp = individual.spouse_suffix.strip
print 'box2_73', tmp if !tmp.empty?

tmp = (individual.address + ' ' + (individual.apartment_number.strip.empty? ? '' : 'Apt. #' + individual.apartment_number)).squeeze(' ').strip[0,39]
print 'box2_10', tmp if !tmp.empty?

tmp = individual.city.strip[0,20]
print 'box2_11', tmp if !tmp.empty?

tmp = individual.state.strip[0,2]
print 'box2_12', tmp if !tmp.empty?

#
# 5 digit zip code - 99999 - defaults to .strip.
#
tmp = (individual.zip.delete(" -") =~ /^(\d{5})(\d{4})?$/ ? $1 : individual.zip.strip)
print 'box2_13', tmp if !tmp.empty?

print 'box2_18', 'X' if !individual.single.strip.empty?
print 'box2_19', 'X' if !individual.married_joint.strip.empty?
print 'box2_20', 'X' if !individual.married_separate.strip.empty?
print 'box2_21', 'X' if !individual.head_of_household.strip.empty?
print 'box2_22', 'X' if !individual.widow_widower.strip.empty?

#
# 10 digit Phone number Validation - (999) 999-9999 - defaults to .strip:
#
# 01/19/15 [HET]: Calcs can post this to signature area(s).

tmp = (case
		when (!individual.work_phone.strip.empty?): individual.work_phone
		when (!individual.phone.strip.empty?): individual.phone
		else individual.mobile_phone
    end).strip
tmp = "(#{$1}) #{$2}-#{$3}" if (tmp.delete("^0-9") =~ /^(\d{3})(\d{3})(\d{4})$/)
print 'box3_69', tmp if !tmp.empty?

tmp = (case
		when (!individual.spouse_work_phone.strip.empty?): individual.spouse_work_phone
		when (!individual.spouse_phone.strip.empty?): individual.spouse_phone
		else individual.spouse_mobile_phone
	end).strip
print 'box3_94', tmp if !tmp.empty?

tmp = "#{individual.first_name} #{individual.last_name}".squeeze(' ').strip
print 'box15_1', tmp if !tmp.empty?

tmp = (individual.fein.strip.empty? ? individual.ssn : individual.fein).strip
print 'box15_2', tmp if !tmp.empty?


tmp = "#{preparer.first_name} #{preparer.middle_initial} #{preparer.last_name}".squeeze(' ').strip[0,22]
print 'box3_56', tmp if !tmp.empty?

#
# 10 digit Phone number Validation - (999) 999-9999 - defaults to .strip:
#
tmp = (case
		when (!preparer.work_phone.strip.empty?): preparer.work_phone
		when (!preparer.phone.strip.empty?): preparer.phone
		else preparer.mobile_phone
    end).strip
tmp = "(#{$1}) #{$2}-#{$3}" if (tmp.delete("^0-9") =~ /^(\d{3})(\d{3})(\d{4})$/)
print 'box3_60', tmp if !tmp.empty?

tmp = preparer.address.strip[0,22]
print 'box3_57', tmp if !tmp.empty?

tmp = preparer.city.strip[0,17]
print 'box3_58', tmp if !tmp.empty?

tmp = preparer.state.strip[0,2]
print 'box3_70', tmp if !tmp.empty?

#
# 5 digit zip code - 99999 - defaults to .strip.
#
tmp = (preparer.zip.delete(" -") =~ /^(\d{5})$/ ? $1 : preparer.zip.strip)
print 'box3_71', tmp if !tmp.empty?

#Form says PTIN, but validation is for PXXXXXXXX or XX-XXXXXX.
#
tmp = (preparer.ptin.strip.empty? ? preparer.fein : preparer.ptin).strip
print 'box3_59', tmp if !tmp.empty?

# End of DataFlow.


#Note 01/19/15:We don't check box control the boxes on page 1, line 11 because they are checked
#in the calcs.

# ##############   CheckBox Control   ##############

# ##############   CheckBox Control   ##############
def CheckBoxCtrl(stateBox, chkList, bdg)

	#-########################################################
	#
	# Method: CheckBoxCtrl
	#
	# One checkbox in a set of checkboxes can be 'on' at a time.
	#
	# stateBox: The hidden box that holds the state of the check boxes from the last execution.
	# chkList: The sets of check boxes we are controlling.
	# bdg: The binding that gives the method read/write access to the boxes.
	#
	# IMPORTANT: THE STATE [HIDDEN] BOX MUST BE LEFT JUSTIFIED FOR THIS ROUTINE TO
	# WORK CORRECTLY.
	#
	# Each array of boxes in chkList is a set of checkboxes where 1 box at a time can be checked.
	# We uncheck the current box in a set when one of the other checkboxes in that set are checked.
	# Each set can be a different size.
	#
	# Note: checkbox sets in which one or more boxes are controlled in dataflow or regular calcs must be
	# excluded here. The user must check the list in the call to this method.
	#
	#-########################################################

	#
	# stateBox is the hidden box which stores the state values of each set in chkList separated by commas.
	# Refer to stateList as an array, init to all zeroes @ startup.
	#
	stateList = (eval("#{stateBox}", bdg).empty? ? "0," * chkList.length : eval("#{stateBox}", bdg)).split(",")

	chkList.each_index do |i|

		#
		# Determine current state expressed as a binary string which we convert to an int.
		# A correct current state is 1 bit is on and the rest are off.
		#
		curState = "0b"
		state = stateList[i].to_i

		chkList[i].each do |box| curState += eval("#{box}.empty? ? '0' : '1'", bdg) end

		curState = Integer(curState)

		#
		# We need to reset a checkbox if curState has more than one bit set.
		#
		unless (curState == state)

			# The minus sign steps into the array from the right end as these are treated as binary numbers.
			print chkList[i][-(Math.frexp(state)[1])], eval("#{chkList[i][-(Math.frexp(state)[1])]}.replace('')", bdg) if ((state & curState) > 0)
			stateList[i] = (state | curState) ^ state

			# Store state_list in the hidden box as a string with each state value separated by a comma and we are done.
			print stateBox, eval("#{stateBox}", bdg).replace(stateList.join(","))
			break
		end
	end
end

# Before we do anything we make sure the state box still exists on the form, else we do nothing with check box control.
if (defined? box1_1)
	CheckBoxCtrl(:box1_1, [[:box2_34,:box2_35,:box2_36],[:box4_5,:box4_6,:box4_7,:box4_8],[:box4_74,:box4_75,:box4_76,:box4_77],[:box4_78,:box4_79,:box4_80,:box4_81],[:box4_82,:box4_83,:box4_84,:box4_85],[:box4_86,:box4_87,:box4_88,:box4_89],[:box4_90,:box4_91,:box4_92,:box4_93]], binding)
end


# ###############   Posting Stuff   ###############

# Header Calcs:

#Note 01/19/15:Per the analyst notes all  header fields that have 2 boxes for the name post just the primary first and last
#names regardless if the field is labeled "Name(s) as shown".

#
# Form RI-1040NR page 2
# 

# 12/12/18 [jgluszek]:  do not truncate name fields per WorkFlow Note.

box3_61 = box2_4
print 'box3_61', box3_61

box3_63 = box2_6
print 'box3_63', box3_63

box3_64 = box2_1
print 'box3_64', box3_64

#
# Form RI-1040NR page 3
#

box4_61 = box2_4
print 'box4_61', box4_61

box4_63 = box2_6
print 'box4_63', box4_63

box4_64 = box2_1
print 'box4_64', box4_64

#Note 12/12/18 [rtroy]:The RI 1040 posts all of the schedules based on user entered data. This form was not
#doing it that way so after a conversation w/the analyst we decided this from should also do it the same way.
#Therefore the rest of the posting will be done just after the calcs. and before the barcodes.

#
#-############################################################
#
# Schedule E
#
# Exemption Schedule for RI-1040 and RI-1040NR
#

if (box18_114 + box18_115 + box18_116 + box18_117 + box18_118 + box18_119 + box18_120 + box18_121 + box18_122 + box18_123 + box18_124 + box18_125 + box18_126 + box18_127 + box18_128 + box18_129 + box18_130 + box18_131 + box18_132 + box18_133 + box18_134 + box18_135 + box18_136 + box18_137 + box18_138 + box18_139 + box18_140 + box18_141 + box18_142 + box18_143 + box18_144 + box18_145 + box18_146 + box18_147 + box18_148 + box18_149 + box18_150 + box18_151 + box18_152 + box18_153 + box18_154 + box18_155 + box18_156 + box18_157 + box18_158 + box18_159 + box18_160 + box18_161 + box18_162 + box18_163 + box18_164 + box18_165 + box18_166 + box18_167 + box18_169 + box18_170 + box18_171).strip.length > 0

	box18_168 = ((!box18_114.strip.empty? ? 1 : 0) + (!box18_115.strip.empty? ? 1 : 0))
	#Note 12/12/18 [rtroy]:This line is adding dependents so it is a whole value.
	box18_172 = '%0.0f' % (box18_168.to_f + box18_169.to_f + box18_170.to_f + box18_171.to_f)
else
	box18_168 = ''
	box18_172 = ''
end
print 'box18_168', box18_168
print 'box18_172', box18_172

#
#-############################################################
#
# Modification Worksheet
#
#

box11_5 = box9_42
print 'box11_5', box11_5

box11_6 = box9_43
print 'box11_6', box11_6

if (!box11_5.strip.empty?)
	box11_7 = '%0.2f' % (box2_23.to_f)
	if (!box2_18.strip.empty?)
		box11_8 = 'SINGLE'
	elsif (!box2_19.strip.empty?)
		box11_8 = 'MARRIED JOINT'
	elsif (!box2_20.strip.empty?)
		box11_8 = 'MARRIED SEPARATE'
	elsif (!box2_21.strip.empty?)
		box11_8 = 'HEAD OF HOUSEHOLD'
	elsif (!box2_22.strip.empty?)
		box11_8 = 'QUALIFYING WIDOW(ER)'
	else
		box11_8 = ''
	end
else
	box11_7 = ''
	box11_8 = ''
end
print 'box11_7', box11_7
print 'box11_8', box11_8

if (box11_7.to_f < box11_10.to_f)
	box11_11 = 'X'
else
	box11_11 = ''
end 
print 'box11_11', box11_11

go = ((!box11_9.strip.empty?) and (!box11_11.strip.empty?)) 

if ((go) and ((box11_12 + box11_13).strip.length > 0))
	box11_14 = '%0.4f' % (box11_12.to_f > 0.0 ? box11_13.to_f / box11_12.to_f : 0)
else
	box11_14 = ''
end
print 'box11_14', box11_14

if ((go) and ((box11_15 + box11_16).strip.length > 0))
	box11_17 = '%0.2f' % (box11_15.to_f * box11_16.to_f / 100.0)
else
	box11_17 = ''
end
print 'box11_17', box11_17

# ###################################################################

#
# Schedule M - Page 1
#

#
# Modifications Decreasing Federal AGI
#

if ((box9_18 + box9_19 + box9_20 + box9_21 + box9_22 + box9_23 + box9_24 + box9_25 + box9_26 + box9_27 + box9_28 + box9_29 + box9_30 + box9_31 + box9_32 + box9_33 + box9_34 + box9_35 + box9_36 + box9_37 + box9_38).strip.length > 0)

	box9_44 = box11_17
	#Note 12/18/17 [rtroy]:Per the line instruction "enter as a negative amount". We can't just put a negative sign
	#before the group of boxes because that fails the converter, so we multiply by a negative 1 instead.
	box9_47 = '%0.2f' % ((box9_18.to_f + box9_19.to_f + box9_20.to_f + box9_21.to_f + box9_22.to_f + box9_23.to_f + box9_24.to_f + box9_25.to_f + box9_26.to_f + box9_27.to_f + box9_28.to_f + box9_29.to_f + box9_30.to_f + box9_31.to_f + box9_32.to_f + box9_33.to_f + box9_34.to_f + box9_35.to_f + box9_36.to_f + box9_37.to_f + box9_44.to_f + box9_38.to_f) * -1.0)
else
	box9_44 = ''
	box9_47 = ''
end

print 'box9_44', box9_44
print 'box9_47', box9_47

#
#-############################################################
#
#
# Schedule M - Page 2
#

#
# Modifications Increasing Federal AGI
#

if ((box10_9 + box10_10 + box10_11 + box10_12 + box10_14 + box10_15 + box10_16).strip.length > 0)

	box10_17 = '%0.2f' % (box10_9.to_f + box10_10.to_f + box10_11.to_f + box10_12.to_f + box10_14.to_f + box10_15.to_f + box10_16.to_f)
else
	box10_17 = ''
end

print 'box10_17', box10_17

if ((box9_38 + box10_17).strip.length > 0)

	box10_43 = box9_47
	box10_44 = box10_17
	box10_39 = '%0.2f' % (box10_43.to_f + box10_44.to_f)
else
	box10_43 = ''
	box10_44 = ''
	box10_39 = ''
end

print 'box10_43', box10_43
print 'box10_44', box10_44
print 'box10_39', box10_39

#
#-############################################################
#
# RI Schedule I - Allowable Federal Credit:
#

# Blanking off from Line 20 - should be ok since this Line is integral to the credit calculation - i.e. they would
# definitely need to enter this line in order to calculate the credit in the first place.

if (box4_2.strip.empty?)
	box4_1 = ''
	box4_3 = ''
	box4_4 = ''
else
	box4_1 = '%0.2f' % (box2_31.to_f)
	box4_3 = '%0.2f' % (box4_2.to_f * 0.25).round
	box4_4 = '%0.2f' % [box4_1.to_f, box4_3.to_f].min
end
print 'box4_1', box4_1
print 'box4_3', box4_3
print 'box4_4', box4_4

#
#-############################################################
#
# Main Form - Got some jumping back and forth....trying to keep it to a minimum...:
#

box2_24 = box10_39
print 'box2_24', box2_24

box2_25 = '%0.2f' % ( box2_23.to_f + box2_24.to_f )
print 'box2_25', box2_25

#
# We cannot calculate the standard deduction since some filers enter an amount from the worksheet on page i.
#

box2_27 = '%0.2f' % ( box2_25.to_f - box2_26.to_f )
print 'box2_27', box2_27

#Note 12/18/17 [rtroy]:The form had been leaving out the exemptions calc. due
#to the chance the worksheet would be used. But since must taxpayers are probably
#under the income threshold I added the calc. and the user can override if necessary. 

box2_28 = box18_172
print 'box2_28', box2_28

box2_29 = (box2_28.strip.empty? ? '' : '%0.2f' % (box2_28.to_f * 4000.0).round)
print 'box2_29', box2_29

box2_30 = '%0.2f' % [box2_27.to_f - box2_29.to_f, 0.0].max
print 'box2_30', box2_30

box2_32 = box4_4
print 'box2_32', box2_32

box2_33 = '%0.2f' % [box2_31.to_f - box2_32.to_f, 0.0].max
print 'box2_33', box2_33

#We need to do a bunch of schedules now so we can post to the main page...

#
#-############################################################
#
# RI Schedule II - NonResident Tax Calculation:
#
# Part 1:
#
if ((box5_9 + box5_10 + box5_11 + box5_12 + box5_13 + box5_14 + box5_15 + box5_16 + box5_17 + box5_18 + box5_19 + box5_20 + box5_21 + box5_22 + box5_25 + box5_26 + box5_29 + box5_30).strip.length == 0)

	box5_23 = ''
	box5_24 = ''
	box5_27 = ''
	box5_28 = ''
	box5_31 = ''
	box5_32 = ''
	box5_33 = ''
	box5_34 = ''
	box5_35 = ''
else
	box5_23 = '%0.2f' % ( box5_9.to_f + box5_11.to_f + box5_13.to_f + box5_15.to_f + box5_17.to_f + box5_19.to_f + box5_21.to_f )
	box5_24 = '%0.2f' % ( box5_10.to_f + box5_12.to_f + box5_14.to_f + box5_16.to_f + box5_18.to_f + box5_20.to_f + box5_22.to_f )
	box5_27 = '%0.2f' % ( box5_23.to_f - box5_25.to_f )
	box5_28 = '%0.2f' % ( box5_24.to_f - box5_26.to_f )
	box5_31 = '%0.2f' % ( box5_27.to_f + box5_29.to_f )
	box5_32 = '%0.2f' % ( box5_28.to_f + box5_30.to_f )
	box5_33 = '%0.4f' % [(box5_32.to_f > 0.0 ? box5_31.to_f / box5_32.to_f : 0.0), 1.0].min
	box5_34 = box2_33
	box5_35 = '%0.2f' % ( box5_34.to_f * box5_33.to_f ).round
end

print 'box5_23', box5_23
print 'box5_24', box5_24
print 'box5_27', box5_27
print 'box5_28', box5_28
print 'box5_31', box5_31
print 'box5_32', box5_32
print 'box5_33', box5_33
print 'box5_34', box5_34
print 'box5_35', box5_35

#
# Part 2:
#
if (box6_9.strip.empty?)
	box6_13 = ''
	box6_14 = ''
	box6_16 = ''
	box6_17 = ''
	box6_18 = ''
else
	box6_13 = '%0.0f' % ( box6_10.to_f + box6_11.to_f + box6_12.to_f )
	box6_14 = '%0.0f' % ( 365.0 - box6_13.to_f )
	box6_16 = '%0.0f' % ( box6_14.to_f - box6_15.to_f )
	box6_17 = '%0.4f' % ( box6_14.to_f > 0.0 ? box6_16.to_f / box6_14.to_f : 0 )
	box6_18 = '%0.2f' % ( box6_9.to_f * box6_17.to_f ).round
end
print 'box6_13', box6_13
print 'box6_14', box6_14
print 'box6_16', box6_16
print 'box6_17', box6_17
print 'box6_18', box6_18

#
# Part 3:
#
if( ( box6_19 + box6_20 + box6_21 + box6_22 + box6_23 + box6_24 + box6_28 + box6_29 + box6_31 + box6_32 ).strip.length == 0 )
	box6_25 = ''
	box6_26 = ''
	box6_27 = ''
	box6_30 = ''
	box6_33 = ''
	box6_34 = ''
	box6_35 = ''
else
	box6_25 = '%0.2f' % ( box6_19.to_f + box6_21.to_f + box6_23.to_f )
	box6_26 = '%0.2f' % ( box6_20.to_f + box6_22.to_f + box6_24.to_f )
	box6_27 = '%0.4f' % ( box6_26.to_f > 0.0 ? box6_25.to_f / box6_26.to_f : 0 )
	box6_30 = '%0.4f' % ( box6_29.to_f > 0.0 ? box6_28.to_f / box6_29.to_f : 0 )
	box6_33 = '%0.4f' % ( box6_32.to_f > 0.0 ? box6_31.to_f / box6_32.to_f : 0 )
	box6_34 = '%0.4f' % ( box6_27.to_f + box6_30.to_f + box6_33.to_f )

	div = (box6_26.to_f > 0.0 ? 1.0 : 0.0) + (box6_29.to_f > 0.0 ? 1.0 : 0.0) + (box6_32.to_f > 0.0 ? 1.0 : 0.0)

	box6_35 = '%0.4f' % (div > 0.0 ? box6_34.to_f / div : 0.0)
end

print 'box6_25', box6_25
print 'box6_26', box6_26
print 'box6_27', box6_27
print 'box6_30', box6_30
print 'box6_33', box6_33
print 'box6_34', box6_34
print 'box6_35', box6_35

if( ( box6_36 + box6_37 ).strip.length == 0 )
	box6_38 = ''
	box6_39 = ''
else
	box6_38 = box6_35
	box6_39 = '%0.2f' % ( box6_37.to_f * box6_38.to_f ).round
end
print 'box6_38', box6_38
print 'box6_39', box6_39

if( ( box6_40 + box6_41 ).strip.length == 0 )
	box6_42 = ''
	box6_43 = ''
else
	box6_42 = box6_35
	box6_43 = '%0.2f' % ( box6_41.to_f * box6_42.to_f ).round
end
print 'box6_42', box6_42
print 'box6_43', box6_43

if( ( box6_44 + box6_45 ).strip.length == 0 )
	box6_46 = ''
	box6_47 = ''
else
	box6_46 = box6_35
	box6_47 = '%0.2f' % ( box6_45.to_f * box6_46.to_f ).round
end
print 'box6_46', box6_46
print 'box6_47', box6_47

if( ( box6_48 + box6_49 ).strip.length == 0 )
	box6_50 = ''
	box6_51 = ''
else
	box6_50 = box6_35
	box6_51 = '%0.2f' % ( box6_49.to_f * box6_50.to_f ).round
end
print 'box6_50', box6_50
print 'box6_51', box6_51

if( ( box6_52 + box6_53 ).strip.length == 0 )
	box6_54 = ''
	box6_55 = ''
else
	box6_54 = box6_35
	box6_55 = '%0.2f' % ( box6_53.to_f * box6_54.to_f ).round
end
print 'box6_54', box6_54
print 'box6_55', box6_55

#
#-############################################################
#
# RI Schedule III - Part-Year Resident Tax Calculation:
#
# Part 1:
#
# Note- the instructions don't specifically say that Column C is Column A minus Column B, but when you read
# the descriptions of the amounts that get entered into each column, it makes logical sense.  Column C (except
# for the adjustments and modifications lines which should not calc) has been calcing since at least 2002 with
# no issues.
#

if( ( box7_11 + box7_12 + box7_14 + box7_15 + box7_16 + box7_18 + box7_19 + box7_20 + box7_22 + box7_23 + box7_24 + box7_26 + box7_27 + box7_28 + box7_30 + box7_31 + box7_32 + box7_34 + box7_35 + box7_36 + box7_38 ).strip.length == 0 )
	box7_13 = ''
	box7_17 = ''
	box7_21 = ''
	box7_25 = ''
	box7_29 = ''
	box7_33 = ''
	box7_37 = ''
	box7_39 = ''
	box7_40 = ''
	box7_41 = ''
	box7_42 = ''
	box7_45 = ''
	box7_47 = ''
	box7_48 = ''
	box7_49 = ''
	box7_50 = ''
	box7_53 = ''
	box7_55 = ''
	box7_56 = ''
	box7_57 = ''
	box7_58 = ''
	box7_59 = ''
	box7_60 = ''
	box7_61 = ''
	box7_62 = ''
else
	box7_13 = '%0.2f' % ( box7_11.to_f - box7_12.to_f )
	box7_17 = '%0.2f' % ( box7_15.to_f - box7_16.to_f )
	box7_21 = '%0.2f' % ( box7_19.to_f - box7_20.to_f )
	box7_25 = '%0.2f' % ( box7_23.to_f - box7_24.to_f )
	box7_29 = '%0.2f' % ( box7_27.to_f - box7_28.to_f )
	box7_33 = '%0.2f' % ( box7_31.to_f - box7_32.to_f )
	box7_37 = '%0.2f' % ( box7_35.to_f - box7_36.to_f )

	box7_39 = '%0.2f' % ( box7_11.to_f + box7_15.to_f + box7_19.to_f + box7_23.to_f + box7_27.to_f + box7_31.to_f + box7_35.to_f )
	box7_40 = '%0.2f' % ( box7_12.to_f + box7_16.to_f + box7_20.to_f + box7_24.to_f + box7_28.to_f + box7_32.to_f + box7_36.to_f )
	box7_41 = '%0.2f' % ( box7_13.to_f + box7_17.to_f + box7_21.to_f + box7_25.to_f + box7_29.to_f + box7_33.to_f + box7_37.to_f )
	box7_42 = '%0.2f' % ( box7_14.to_f + box7_18.to_f + box7_22.to_f + box7_26.to_f + box7_30.to_f + box7_34.to_f + box7_38.to_f )

	box7_45 = '%0.2f' % ( box7_43.to_f - box7_44.to_f )

	box7_47 = '%0.2f' % ( box7_39.to_f - box7_43.to_f )
	box7_48 = '%0.2f' % ( box7_40.to_f - box7_44.to_f )
	box7_49 = '%0.2f' % ( box7_41.to_f - box7_45.to_f )
	box7_50 = '%0.2f' % ( box7_42.to_f - box7_46.to_f )

	box7_53 = '%0.2f' % ( box7_51.to_f - box7_52.to_f )

	box7_55 = '%0.2f' % ( box7_47.to_f + box7_51.to_f )
	box7_56 = '%0.2f' % ( box7_48.to_f + box7_52.to_f )
	box7_57 = '%0.2f' % ( box7_49.to_f + box7_53.to_f )
	box7_58 = '%0.2f' % ( box7_50.to_f + box7_54.to_f )

	box7_59 = '%0.2f' % ( box7_56.to_f + box7_58.to_f )
	box7_60 = '%0.4f' % [(box7_55.to_f > 0.0 ? box7_59.to_f / box7_55.to_f : 0.0), 1.0].min
	box7_61 = box2_33
	box7_62 = '%0.2f' % ( box7_61.to_f * box7_60. to_f ).round
end

print 'box7_13', box7_13
print 'box7_17', box7_17
print 'box7_21', box7_21
print 'box7_25', box7_25
print 'box7_29', box7_29
print 'box7_33', box7_33
print 'box7_37', box7_37
print 'box7_39', box7_39
print 'box7_40', box7_40
print 'box7_41', box7_41
print 'box7_42', box7_42
print 'box7_45', box7_45
print 'box7_47', box7_47
print 'box7_48', box7_48
print 'box7_49', box7_49
print 'box7_50', box7_50
print 'box7_53', box7_53
print 'box7_55', box7_55
print 'box7_56', box7_56
print 'box7_57', box7_57
print 'box7_58', box7_58
print 'box7_59', box7_59
print 'box7_60', box7_60
print 'box7_61', box7_61
print 'box7_62', box7_62

#
# Part 2:
#

if( (box8_10 ).strip.length == 0 )

	box8_9 = ''
	box8_11 = ''
	box8_12 = ''
	box8_13 = ''
	box8_16 = ''
	box8_18 = ''
	box8_19 = ''
	box8_20 = ''
	box8_21 = ''
else
	box8_9 = box7_62
	box8_11 = box7_59
	box8_12 = '%0.4f' % ( box8_11.to_f > 0.0 ? box8_10.to_f / box8_11.to_f : 0 )
	box8_13 = '%0.2f' % ( box8_9.to_f * box8_12.to_f ).round
	box8_16 = '%0.2f' % ( box8_10.to_f )
	box8_18 = '%0.4f' % ( box8_17.to_f > 0.0 ? box8_16.to_f / box8_17.to_f : 0 )
	box8_19 = '%0.2f' % ( box8_15.to_f * box8_18.to_f ).round
	box8_20 = '%0.2f' % [box8_9.to_f, box8_13.to_f, box8_19.to_f].min
	box8_21 = '%0.2f' % ( box8_9.to_f - box8_20.to_f )
end
print 'box8_9', box8_9
print 'box8_11', box8_11
print 'box8_12', box8_12
print 'box8_13', box8_13
print 'box8_16', box8_16
print 'box8_18', box8_18
print 'box8_19', box8_19
print 'box8_20', box8_20
print 'box8_21', box8_21

#
#-############################################################
#
# RI Schedule CR - Other RI Credits:

#
if ((box12_25 + box12_9 + box12_10 + box12_22 + box12_23 + box12_11 + box12_24).strip.length == 0)

	box12_12 = ''
else
	box12_12 = '%0.2f' % (box12_25.to_f + box12_9.to_f + box12_10.to_f + box12_22.to_f + box12_23.to_f + box12_11.to_f + box12_24.to_f)
end
print 'box12_12', box12_12

# RI Schedule CR - Recapture of Prior Year Credits:
if ((box12_15 + box12_18).strip.length > 0)

	box12_19 =  '%0.2f' % (box12_15.to_f + box12_18.to_f)
else
	box12_19 = ''
end
print 'box12_19', box12_19

#
#-############################################################
#
# RI 1040MU: 
#

#
# Part 1
#

#Note 12/08/16 [rtroy]:We should be OK blanking w/ these 3 lines as triggers esp. since
#the user has to fill in line 3 for income taxed by other state to drive each part.

if ((box13_5 + box13_10 + box13_12).strip.length > 0)

	box13_3 = box7_62
	box13_4 = box7_62
	box13_6 = box7_59
	#Note 12/12/16 [rtroy]:The grid in the specs. for this schedule shows the division lines going out 4 places.
	box13_7 = '%0.4f' % (box13_6.to_f > 0.0 ? box13_5.to_f / box13_6.to_f : 0.0)
	box13_8 = '%0.2f' % (box13_4.to_f * box13_7.to_f).round
	box13_11 = '%0.2f' % (box13_5.to_f)
	box13_13 = '%0.4f' % (box13_12.to_f > 0.0 ? box13_11.to_f / box13_12.to_f : 0.0)
	box13_14 = '%0.2f' % (box13_10.to_f * box13_13.to_f).round
	box13_15 = '%0.2f' % [box13_4.to_f, box13_8.to_f, box13_14.to_f].min
else
	box13_3 =''
	box13_4 = ''
	box13_6 = ''
	box13_7 = ''
	box13_8 = ''
	box13_11 = ''
	box13_13 = ''
	box13_14 = ''
	box13_15 = ''
end

print 'box13_3', box13_3
print 'box13_4', box13_4
print 'box13_6', box13_6
print 'box13_7', box13_7
print 'box13_8', box13_8
print 'box13_11', box13_11
print 'box13_13', box13_13
print 'box13_14', box13_14
print 'box13_15', box13_15

if ((box13_17 + box13_22 + box13_24).strip.length > 0)

	box13_16 = box7_62
	box13_18 = box7_59
	#Note 12/12/16 [rtroy]:The grid in the specs. for this schedule shows the division lines going out 4 places.
	box13_19 = '%0.4f' % (box13_18.to_f > 0.0 ? box13_17.to_f / box13_18.to_f : 0.0)
	box13_20 = '%0.2f' % (box13_16.to_f * box13_19.to_f).round
	box13_23 = '%0.2f' % (box13_17.to_f)
	box13_25 = '%0.4f' % (box13_24.to_f > 0.0 ? box13_23.to_f / box13_24.to_f : 0.0)
	box13_26 = '%0.2f' % (box13_22.to_f * box13_25.to_f).round
	box13_27 = '%0.2f' % [box13_16.to_f, box13_20.to_f, box13_26.to_f].min
else
	box13_16 = ''
	box13_18 = ''
	box13_19 = ''
	box13_20 = ''
	box13_23 = ''
	box13_25 = ''
	box13_26 = ''
	box13_27 = ''
end

print 'box13_16', box13_16
print 'box13_18', box13_18
print 'box13_19', box13_19
print 'box13_20', box13_20
print 'box13_23', box13_23
print 'box13_25', box13_25
print 'box13_26', box13_26
print 'box13_27', box13_27

if ((box13_29 + box13_34 + box13_36).strip.length > 0)

	box13_28 = box7_62
	box13_30 = box7_59
	#Note 12/12/16 [rtroy]:The grid in the specs. for this schedule shows the division lines going out 4 places.
	box13_31 = '%0.4f' % (box13_30.to_f > 0.0 ? box13_29.to_f / box13_30.to_f : 0.0)
	box13_32 = '%0.2f' % (box13_28.to_f * box13_31.to_f).round
	box13_35 = '%0.2f' % (box13_29.to_f)
	box13_37 = '%0.4f' % (box13_36.to_f > 0.0 ? box13_35.to_f / box13_36.to_f : 0.0)
	box13_38 = '%0.2f' % (box13_34.to_f * box13_37.to_f).round
	box13_39 = '%0.2f' % [box13_28.to_f, box13_32.to_f, box13_38.to_f].min
else
	box13_28 = ''
	box13_30 = ''
	box13_31 = ''
	box13_32 = ''
	box13_35 = ''
	box13_37 = ''
	box13_38 = ''
	box13_39 = ''
end

print 'box13_28', box13_28
print 'box13_30', box13_30
print 'box13_31', box13_31
print 'box13_32', box13_32
print 'box13_35', box13_35
print 'box13_37', box13_37
print 'box13_38', box13_38
print 'box13_39', box13_39

if ((box13_3 + box13_15 + box13_27 + box13_39).strip.length > 0)

	box13_40 = '%0.2f' % [box13_3.to_f - box13_15.to_f - box13_27.to_f - box13_39.to_f, 0.0].max
else
	box13_40 = ''
end

print 'box13_40', box13_40

#
#-############################################################
#
# RI Schedule U: 
#
#
# Option 1:
#
if ((box14_4 + box14_6).strip.length > 0)
	box14_5 = '%0.2f' % (box14_4.to_f * 0.07).round
	box14_7 = '%0.2f' % [box14_5.to_f - box14_6.to_f, 0.0].max
else
	box14_5 = ''
	box14_7 = ''
end
print 'box14_5', box14_5
print 'box14_7', box14_7

#
# Option 2:
#

box14_8 = '%0.2f' % (box2_23.to_f)
print 'box14_8', box14_8

# 12/21/15 [htruax]: Using Line 5 as the trigger for this calc.
#
if (box14_8.strip.length > 0)

	if (box14_8.to_f < 0.0)
		box14_9 = '%0.2f' % 0.0
	else
		box14_9 = '%0.2f' % case (box14_8.to_f)

			when (0...6500): 5.0
			when (6500...13050): 10.0
			when (13050...19550): 15.0
			when (19550...26100): 20.0
			when (26100...32600): 25.0
			when (32600...39150): 30.0
			when (39150...45650): 35.0
			when (45650...52200): 40.0
			when (52200...58750): 45.0
			when (58750...65250): 50.0
			when (65250...71800): 55.0
			when (71800...78300): 60.0
			else (box14_8.to_f * 0.0008).round
		end
	end
else
	box14_9 = ''
end
print 'box14_9', box14_9

if ((box14_11 + box14_13).strip.length > 0)
	box14_12 = '%0.2f' % (box14_11.to_f * 0.07).round
	box14_14 = '%0.2f' % [box14_12.to_f - box14_13.to_f, 0.0].max
else
	box14_12 = ''
	box14_14 = ''
end
print 'box14_12', box14_12
print 'box14_14', box14_14

if ((box14_16 + box14_18).strip.length > 0)
	box14_17 = '%0.2f' % (box14_16.to_f * 0.07).round
	box14_19 = '%0.2f' % [box14_17.to_f - box14_18.to_f, 0.0].max
else
	box14_17 = ''
	box14_19 = ''
end
print 'box14_17', box14_17
print 'box14_19', box14_19

if ((box14_21 + box14_23).strip.length > 0)
	box14_22 = '%0.2f' % (box14_21.to_f * 0.07).round
	box14_24 = '%0.2f' % [box14_22.to_f - box14_23.to_f, 0.0].max
else
	box14_22 = ''
	box14_24 = ''
end
print 'box14_22', box14_22
print 'box14_24', box14_24

if ((box14_26 + box14_28).strip.length > 0)
	box14_27 = '%0.2f' % (box14_26.to_f * 0.07).round
	box14_29 = '%0.2f' % [box14_27.to_f - box14_28.to_f, 0.0].max
else
	box14_27 = ''
	box14_29 = ''
end
print 'box14_27', box14_27
print 'box14_29', box14_29

if ((box14_14 + box14_19 + box14_24 + box14_29).strip.length > 0)
	box14_30 = '%0.2f' % (box14_14.to_f + box14_19.to_f + box14_24.to_f + box14_29.to_f)
else
	box14_30 = ''
end
print 'box14_30', box14_30

if ((box14_9 + box14_30).strip.length > 0)
	box14_31 = '%0.2f' % (box14_9.to_f + box14_30.to_f)
else
	box14_31 = ''
end
print 'box14_31', box14_31

#
#-############################################################
#
# RI Schedule W - Rhode Island W2 and 1099 Information:
#

if ((box17_7 + box17_12 + box17_17 + box17_22 + box17_27 + box17_32 + box17_37 + box17_42 + box17_47 + box17_52 + box17_57 + box17_62 + box17_67 + box17_72 + box17_77).strip.length > 0)

	box17_103 = '%0.2f' % (box17_7.to_f + box17_12.to_f + box17_17.to_f + box17_22.to_f + box17_27.to_f + box17_32.to_f + box17_37.to_f + box17_42.to_f + box17_47.to_f + box17_52.to_f + box17_57.to_f + box17_62.to_f + box17_67.to_f + box17_72.to_f + box17_77.to_f)
else
	box17_103 = ''
end

print 'box17_103', box17_103

#
#-############################################################
#
# RI Checkoff Contributions Schedule:
#
box4_10 = if( !box4_5.strip.empty? ) then '1.00'
		elsif( !box4_6.strip.empty? ) then '5.00'
		elsif( !box4_7.strip.empty? ) then '10.00'
		elsif( !box4_8.strip.empty? ) then '%0.2f' % ( box4_9.to_f )
		else ''
		end
print 'box4_10', box4_10

#Note 12/18/17 [rtroy]:We have to code this one the long way because of the converter.
box4_12 = if ((!box4_11.strip.empty?) and (!box2_19.strip.empty?)) then '2.00'
		elsif	((!box4_11.strip.empty?) and (box2_19.strip.empty?)) then '1.00'
		else ''
		end
print 'box4_12', box4_12

box4_18 = if( !box4_74.strip.empty? ) then '1.00'
		elsif( !box4_75.strip.empty? ) then '5.00'
		elsif( !box4_76.strip.empty? ) then '10.00'
		elsif( !box4_77.strip.empty? ) then '%0.2f' % ( box4_17.to_f )
		else ''
		end
print 'box4_18', box4_18

box4_24 = if( !box4_78.strip.empty? ) then '1.00'
		elsif( !box4_79.strip.empty? ) then '5.00'
		elsif( !box4_80.strip.empty? ) then '10.00'
		elsif( !box4_81.strip.empty? ) then '%0.2f' % ( box4_23.to_f )
		else ''
		end
print 'box4_24', box4_24

box4_30 = if( !box4_82.strip.empty? ) then '1.00'
		elsif( !box4_83.strip.empty? ) then '5.00'
		elsif( !box4_84.strip.empty? ) then '10.00'
		elsif( !box4_85.strip.empty? ) then '%0.2f' % ( box4_29.to_f )
		else ''
		end
print 'box4_30', box4_30

box4_36 = if( !box4_86.strip.empty? ) then '1.00'
		elsif( !box4_87.strip.empty? ) then '5.00'
		elsif( !box4_88.strip.empty? ) then '10.00'
		elsif( !box4_89.strip.empty? ) then '%0.2f' % ( box4_35.to_f )
		else ''
		end
print 'box4_36', box4_36

box4_42 = if( !box4_90.strip.empty? ) then '1.00'
		elsif( !box4_91.strip.empty? ) then '5.00'
		elsif( !box4_92.strip.empty? ) then '10.00'
		elsif( !box4_93.strip.empty? ) then '%0.2f' % ( box4_41.to_f )
		else ''
		end
print 'box4_42', box4_42

if( ( box4_10 + box4_12 + box4_18 + box4_24 + box4_30 + box4_36 + box4_42 ).strip.length == 0 )
	box4_43 = ''
else
	box4_43 = '%0.2f' % ( box4_10.to_f + box4_12.to_f + box4_18.to_f + box4_24.to_f + box4_30.to_f + box4_36.to_f + box4_42.to_f )
end
print 'box4_43', box4_43

#
#-############################################################
#
# RI Schedule EIC - Rhode Island Earned Income Credit:
#

if( box4_45.strip.empty? )

	box4_46 = ''
	box4_50 = ''
	box4_52 = ''
else
	box4_46 = '%0.2f' % ( box4_45.to_f * 0.15 ).round	
	box4_50 = (box5_33.strip.empty? ? box7_60 : box5_33)
	box4_52 = '%0.2f' % ( box4_46.to_f * box4_50.to_f ).round
end

print 'box4_46', box4_46
print 'box4_50', box4_50
print 'box4_52', box4_52

#
# Form RI-2210 (Page 1)
#
#-###################################################################
# 				(enter as 100.00 - Amount will display 100 00)
#-###################################################################
#
# Part 1: Required Annual Payment:
#
if ((box15_3 + box15_5 + box15_7).strip.length > 0)

	box15_4 ='%0.2f' % (box15_3.to_f * 0.8).round
	box15_6 = '%0.2f' % (box15_3.to_f - box15_5.to_f)
	box15_8 = (box15_6.to_f > 250.0 ? '%0.2f' % [box15_4.to_f, box15_7.to_f].min : '')
else
	box15_4 = ''
	box15_6 = ''
	box15_8 = ''
end

print 'box15_4', box15_4
print 'box15_6', box15_6
print 'box15_8', box15_8

#
#-###################################################################
#
# Part 2: Shortcut Method. "....Otherwise, you must complete parts 3 and 4......"
#
if ((box15_9 + box15_10 + box15_13).strip.length > 0)

	box15_11 = '%0.2f' % (box15_9.to_f > box15_10.to_f ? box15_9.to_f - box15_10.to_f : 0.0)
	box15_12 = '%0.2f' % (box15_11.to_f * 0.120205).round
	box15_14 = '%0.2f' % (box15_12.to_f - box15_13.to_f)
else
	box15_11 = ''
	box15_12 = ''
	box15_14 = ''
end
print 'box15_11', box15_11
print 'box15_12', box15_12
print 'box15_14', box15_14

line6_div_4 = '%0.2f' % (box15_8.to_f / 4.0)

#
#-###################################################################
#
# Part 5 - Annualized Income Installment Worksheet: Locked out if they do Part 2 [and they get past Line 4 of Part 1].
#
box16_36 = box15_1
print 'box16_36', box16_36

box16_37 = box15_2
print 'box16_37', box16_37

box16_2 = ''
box16_4 = ''
box16_5 = ''
box16_6 = ''
box16_7 = ''
box16_8 = ''
box16_10 = ''
box16_12 = ''
box16_13 = ''
box16_14 = ''
box16_15 = ''
box16_16 = ''
box16_17 = ''
box16_19 = ''
box16_21 = ''
box16_22 = ''
box16_23 = ''
box16_24 = ''
box16_25 = ''
box16_26 = ''
box16_28 = ''
box16_30 = ''
box16_31 = ''
box16_32 = ''
box16_33 = ''
box16_34 = ''
box16_35 = ''

#Note 12/13/18 [rtroy]:User isn't using the Part 2 shortcut method and the has filled out Part 1.

if ((box15_14.empty?) and (!box15_8.empty?))

	if ((box16_1 + box16_3 + box16_9 + box16_11 + box16_18 + box16_20 + box16_27 + box16_29).strip.length > 0)
	
		box16_2 = '%0.2f' % ( box16_1.to_f * 4.0 ).round
		box16_4 = '%0.2f' % ( box16_3.to_f * 0.2 ).round
		# Box on Line 29, column 1 really should not be on the form....le sigh....
		box16_5 = '%0.2f' % [box16_4.to_f - box16_38.to_f, 0.0].max
		box16_6 = '%0.2f' % (line6_div_4.to_f).round
		box16_7 = '%0.2f' % ( box16_6.to_f > box16_5.to_f ? box16_6.to_f - box16_5.to_f : 0 )
		box16_8 = '%0.2f' % ( box16_5.to_f < box16_6.to_f ? box16_5.to_f : box16_6.to_f )
	
		box16_10 = '%0.2f' % ( box16_9.to_f * 2.4 ).round
		box16_12 = '%0.2f' % ( box16_11.to_f * 0.4 ).round
		box16_13 = box16_8
		box16_14 = '%0.2f' % ( box16_12.to_f > box16_13.to_f ? box16_12.to_f - box16_13.to_f : 0 )
		box16_15 = '%0.2f' % (line6_div_4.to_f + box16_7.to_f)
		box16_16 = '%0.2f' % ( box16_15.to_f > box16_14.to_f ? box16_15.to_f - box16_14.to_f : 0 )
		box16_17 = '%0.2f' % ( box16_14.to_f < box16_15.to_f ? box16_14.to_f : box16_15.to_f )
	
		box16_19 = '%0.2f' % ( box16_18.to_f * 1.5 ).round
		box16_21 = '%0.2f' % ( box16_20.to_f * 0.6 ).round
		box16_22 = '%0.2f' % ( box16_8.to_f + box16_17.to_f )
		box16_23 = '%0.2f' % ( box16_21.to_f > box16_22.to_f ? box16_21.to_f - box16_22.to_f : 0 )
		box16_24 = '%0.2f' % (line6_div_4.to_f + box16_16.to_f)
		box16_25 = '%0.2f' % ( box16_24.to_f > box16_23.to_f ? box16_24.to_f - box16_23.to_f : 0 )
		box16_26 = '%0.2f' % ( box16_23.to_f < box16_24.to_f ? box16_23.to_f : box16_24.to_f )
	
		box16_28 = '%0.2f' % ( box16_27.to_f )
		box16_30 = '%0.2f' % ( box16_29.to_f * 0.8 ).round
		box16_31 = '%0.2f' % ( box16_8.to_f + box16_17.to_f + box16_26.to_f )
		box16_32 = '%0.2f' % ( box16_30.to_f > box16_31.to_f ? box16_30.to_f - box16_31.to_f : 0 )
		box16_33 = '%0.2f' % (box15_8.to_f - (line6_div_4.to_f * 3.0) + box16_25.to_f).round
		box16_34 = '%0.2f' % ( box16_33.to_f > box16_32.to_f ? box16_33.to_f - box16_32.to_f : 0 )
		box16_35 = '%0.2f' % ( box16_32.to_f < box16_33.to_f ? box16_32.to_f : box16_33.to_f )
	end
end

print 'box16_2', box16_2
print 'box16_4', box16_4
print 'box16_5', box16_5
print 'box16_6', box16_6
print 'box16_7', box16_7
print 'box16_8', box16_8
print 'box16_10', box16_10
print 'box16_12', box16_12
print 'box16_13', box16_13
print 'box16_14', box16_14
print 'box16_15', box16_15
print 'box16_16', box16_16
print 'box16_17', box16_17
print 'box16_19', box16_19
print 'box16_21', box16_21
print 'box16_22', box16_22
print 'box16_23', box16_23
print 'box16_24', box16_24
print 'box16_25', box16_25
print 'box16_26', box16_26
print 'box16_28', box16_28
print 'box16_30', box16_30
print 'box16_31', box16_31
print 'box16_32', box16_32
print 'box16_33', box16_33
print 'box16_34', box16_34
print 'box16_35', box16_35

#
#-###################################################################
#
# Part 3 - Figure Your Underpants: Default to this as long as Line 4 condition is met and Part 2 has not been completed.
#


if ((box15_14.empty?) and (!box15_8.empty?))

	box15_15 = '%0.2f' % (line6_div_4.to_f).round
	box15_16 = box16_8
	box15_17 = '%0.2f' % (box15_16.empty? ? box15_15.to_f : box15_16.to_f).round
	box15_19 = '%0.2f' % ((box15_17.to_f - box15_18.to_f).abs).round

	box15_20 = '%0.2f' % (line6_div_4.to_f).round
	box15_21 = box16_17
	box15_22 = '%0.2f' % (box15_21.empty? ? box15_20.to_f : box15_21.to_f).round
	box15_24 = '%0.2f' % ((box15_22.to_f - box15_23.to_f).abs).round

	box15_25 = '%0.2f' % (line6_div_4.to_f).round
	box15_26 = box16_26
	box15_27 = '%0.2f' % (box15_26.empty? ? box15_25.to_f : box15_26.to_f).round
	box15_29 = '%0.2f' % ((box15_27.to_f - box15_28.to_f).abs).round

	box15_30 = '%0.2f' % (box15_8.to_f - box15_15.to_f - box15_20.to_f - box15_25.to_f)
	box15_31 = box16_35
	box15_32 = '%0.2f' % (box15_31.empty? ? box15_30.to_f : box15_31.to_f)
	box15_34 = '%0.2f' % ((box15_32.to_f - box15_33.to_f).abs).round
else
	box15_15 = ''
	box15_16 = ''
	box15_17 = ''
	box15_19 = ''
	box15_20 = ''
	box15_21 = ''
	box15_22 = ''
	box15_24 = ''
	box15_25 = ''
	box15_26 = ''
	box15_27 = ''
	box15_29 = ''
	box15_30 = ''
	box15_31 = ''
	box15_32 = ''
	box15_34 = ''
end

print 'box15_15', box15_15
print 'box15_16', box15_16
print 'box15_17', box15_17
print 'box15_19', box15_19
print 'box15_20', box15_20
print 'box15_21', box15_21
print 'box15_22', box15_22
print 'box15_24', box15_24
print 'box15_25', box15_25
print 'box15_26', box15_26
print 'box15_27', box15_27
print 'box15_29', box15_29
print 'box15_30', box15_30
print 'box15_31', box15_31
print 'box15_32', box15_32
print 'box15_34', box15_34

#
#-###################################################################
#
# Part 4 - How to Figure the Charges - Locked out if Part 4 line condition is not met or they do Part 2:
#
box16_43 = ''
box16_46 = ''
box16_49 = ''
box16_51 = ''
box16_54 = ''
box16_55 = ''

if ((box15_14.empty?) and (!box15_8.empty?))
	#NEST
	if ((box16_41 + box16_42).strip.length > 0)
		box16_43 = '%0.2f' % (box15_17.to_f > box15_18.to_f ? box16_42.to_f / 365.0 * 0.18 * box15_19.to_f : 0.0).round
	end
	
	if ((box16_44 + box16_45).strip.length > 0)
		box16_46 = '%0.2f' % (box15_22.to_f > box15_23.to_f ? box16_45.to_f / 365.0 * 0.18 * box15_24.to_f : 0.0).round
	end
	
	if ((box16_47 + box16_48 + box16_50).strip.length > 0)
		box16_49 = '%0.2f' % (box15_27.to_f > box15_28.to_f ? box16_48.to_f / 365.0 * 0.18 * box15_29.to_f : 0.0).round
		box16_51 = '%0.2f' % (box15_27.to_f > box15_28.to_f ? box16_50.to_f / 365.0 * 0.18 * box15_29.to_f : 0.0).round
	end
	
	if ((box16_52 + box16_53).strip.length > 0)
		box16_54 = '%0.2f' % (box15_32.to_f > box15_33.to_f ? box16_53.to_f / 365.0 * 0.18 * box15_34.to_f : 0.0).round
	end
	
	if ((box16_43 + box16_46 + box16_49 + box16_51 + box16_54).strip.length > 0)
		box16_55 = '%0.2f' % (box16_43.to_f + box16_46.to_f + box16_49.to_f + box16_51.to_f + box16_54.to_f)
	end
end
print 'box16_43', box16_43
print 'box16_46', box16_46
print 'box16_49', box16_49
print 'box16_51', box16_51
print 'box16_54', box16_54
print 'box16_55', box16_55

#
#-############################################################
#
# Back to Main Form:
#

box2_34 = ''
box2_35 = ''
box2_36 = ''

case
	when (!box8_21.strip.empty?)

		#
		# Part-Year Resident with....
		#
		box2_36 = 'X'
		box2_37 = box8_21

	when (!box7_62.strip.empty?)

		#
		# Part-Year Resident with....
		#
		box2_36 = 'X'
		box2_37 = box7_62

	when (!box5_35.strip.empty?)

		#
		# Non-Resident with....
		#
		box2_35 = 'X'
		box2_37 = box5_35
	else

		#
		# All income is from RI.
		#
		box2_34 = 'X'
		box2_37 = box2_33
end

print 'box2_34', box2_34
print 'box2_35', box2_35
print 'box2_36', box2_36
print 'box2_37', box2_37

box2_38 = box12_12
print 'box2_38', box2_38

box2_39 = '%0.2f' % [box2_37.to_f - box2_38.to_f, 0.0].max
print 'box2_39', box2_39

box2_40 = box12_19
print 'box2_40', box2_40

box2_41 = box4_43
print 'box2_41', box2_41

box2_42 = (box14_31.strip.empty? ? box14_7 : box14_31)
print 'box2_42', box2_42

box2_43 = '%0.2f' % (box2_39.to_f + box2_40.to_f + box2_41.to_f + box2_42.to_f)
print 'box2_43', box2_43

box3_86 = box2_43
print 'box3_86', box3_86

box3_74 = box17_103
print 'box3_74', box3_74

box3_77 = box4_52
print 'box3_77', box3_77

box3_79 = '%0.2f' % ( box3_74.to_f + box3_75.to_f + box3_76.to_f + box3_77.to_f + box3_78.to_f )
print 'box3_79', box3_79

box3_88 = '%0.2f' % [box3_79.to_f - box3_87.to_f, 0.0].max
print 'box3_88',  box3_88

# 1/8/19 - DAS - wants Line 18b to be from box15_14

#Note 12/19/17 [rtroy]: Per the line instructions an amount on line 18b underestimating
#interest due is greater than an overpayment it kicks the overpayment to an amount due...
#"If the amount of underestimating interest due on line 18b is more than the amount of
#overpayment from line 19, subtract line 19 from line 18b and enter the result on line 18c."

tax_due_or_refund = (box3_86.to_f - box3_88.to_f)

if ((tax_due_or_refund + box15_14.to_f) < 0.0)
	#
	# Overpaid:
	#
	box3_80 = ''
	box3_81 = box15_14
	box3_82 = '%0.2f' % (0.0)
	box3_83 = '%0.2f' % (tax_due_or_refund + box15_14.to_f).abs
	box3_84 = '%0.2f' % [box3_83.to_f - box3_85.to_f, 0.0].max
	#
	# Overpaid but...underestimated interest due was greater then overpayment.
	#
elsif ((tax_due_or_refund < 0.0) and (tax_due_or_refund + box15_14.to_f) > 0.0)
	box3_80 = ''
	box3_81 = box15_14
	box3_82 = '%0.2f' % (tax_due_or_refund + box15_14.to_f)
	box3_83 = '%0.2f' % (0.0)
	box3_84 = ''
else ((tax_due_or_refund + box15_14.to_f)  > 0.0)
	#
	# Amount Due:
	#
	box3_80 = '%0.2f' % (tax_due_or_refund)
	box3_81 = box15_14
	box3_82 = '%0.2f' % (tax_due_or_refund + box15_14.to_f)
	box3_83 = '%0.2f' % (0.0)
	box3_84 = ''

end

print 'box3_80', box3_80
print 'box3_81', box3_81
print 'box3_82', box3_82
print 'box3_83', box3_83
print 'box3_84', box3_84

# ##################   Posting   ####################

#Note 12/12/18 [rtroy]:As promised above this is all the posting for the schedules based on user entered data.

#
# Schedule II page 1 ( Posting)
#

if ((box5_9 + box5_10 + box5_11 + box5_12 + box5_13 + box5_14 + box5_15 + box5_16 + box5_17 + box5_18 + box5_19 + box5_20 + box5_21 + box5_22 + box5_25 + box5_26).strip.length > 0)
	box5_1 = box2_4
	box5_3 = box2_6
	box5_4 = box2_1
	
else
	box5_1 = ''
	box5_3 = ''
	box5_4 = ''
end
print 'box5_1', box5_1
print 'box5_3', box5_3
print 'box5_4', box5_4

#
# Schedule II page 2 ( Posting)
#

if ((box6_9 + box6_10 + box6_11 + box6_12 + box6_15 + box6_19 + box6_20 + box6_21 + box6_22 + box6_23 + box6_24 + box6_28 + box6_29 + box6_31 + box6_32 + box6_36 + box6_37 + box6_38 + box6_40 + box6_41 + box6_42 + box6_44 + box6_45 + box6_46 + box6_48 + box6_49 + box6_50 + box6_52 + box6_53 + box6_54).strip.length > 0)
	box6_1 = box2_4
	box6_3 = box2_6
	box6_4 = box2_1
else
	box6_1 = ''
	box6_3 = ''
	box6_4 = ''
end
print 'box6_1', box6_1	
print 'box6_3', box6_3
print 'box6_4', box6_4

#
# Schedule III pages 1 & 2 page 1 ( Posting)
#

if ((box7_9 + box7_10 + box7_11 + box7_12 + box7_13 + box7_14 + box7_15 + box7_16 + box7_17 + box7_18 + box7_19 + box7_20 + box7_21 + box7_22 + box7_23 + box7_24 + box7_25 + box7_26 + box7_27 + box7_28 + box7_29 + box7_30 + box7_31 + box7_32 + box7_33 + box7_34 + box7_35 + box7_36 + box7_37 + box7_38 + box7_43 + box7_44 + box7_45 + box7_46 + box8_9 + box8_10 + box8_15 + box8_17).strip.length > 0)

	box7_1 = box2_4
	box7_3 = box2_6
	box7_4 = box2_1
	box8_1 = box2_4
	box8_3 = box2_6
	box8_4 = box2_1
else
	box7_1 = ''
	box7_3 = ''
	box7_4 = ''
	box8_1 = ''
	box8_3 = ''
	box8_4 = ''
end
print 'box7_1', box7_1
print 'box7_3', box7_3
print 'box7_4', box7_4
print 'box8_1', box8_1
print 'box8_3', box8_3
print 'box8_4', box8_4

#
# Schedule M page 1 (Posting)
#

if ((box9_18 + box9_19 + box9_20 + box9_21 + box9_22 + box9_23 + box9_24 + box9_25 + box9_26 + box9_27 + box9_28 + box9_29 + box9_30 + box9_31 + box9_32 + box9_33 + box9_34 + box9_35 + box9_36 + box9_37 + box9_44 + box9_38).strip.length > 0)
	box9_1 = box2_4
	box9_3 = box2_6
	box9_4 = box2_1
else
	box9_1 = ''
	box9_3 = ''
	box9_4 = ''
end
print 'box9_1', box9_1
print 'box9_3', box9_3
print 'box9_4', box9_4

#
# Schedule M page 2 (Posting)
#

if ((box10_9 + box10_10 + box10_11 + box10_12 + box10_14 + box10_15 + box10_16).strip.length > 0)
	box10_40= box2_4
	box10_41 = box2_6
	box10_42 = box2_1
else
	box10_40 = ''
	box10_41 = ''
	box10_42 = ''
end
print 'box10_40', box10_40
print 'box10_41', box10_41
print 'box10_42', box10_42

#
# Modification Worksheet  (Posting)
#

if ((box11_5 + box11_6 + box11_9 + box11_10 + box11_12 + box11_13 + box11_15 + box11_16).strip.length > 0)
	box11_1 = box2_4
	box11_3 = box2_6
	box11_4 = box2_1
else
	box11_1 = ''
	box11_3 = ''
	box11_4 = ''
end
print 'box11_1', box11_1
print 'box11_3', box11_3
print 'box11_4', box11_4

#
# Schedule CR  (Posting)
#

if ((box12_25 + box12_9 + box12_10 + box12_22 + box12_23 + box12_11 + box12_24 + box12_13 + box12_14 + box12_15 + box12_16 + box12_17 + box12_18).strip.length > 0)
	box12_1 = box2_4
	box12_3 = box2_6
	box12_4 = box2_1
else
	box12_1 = ''
	box12_3 = ''
	box12_4 = ''
end
print 'box12_1', box12_1
print 'box12_3', box12_3
print 'box12_4', box12_4

#
# Form RI-1040NR-MU  (Posting)
#

if ((box13_3 + box13_5 + box13_10 + box13_12 + box13_17 + box13_21 +  box13_22 +  box13_24 + box13_29 + box13_33 + box13_34 + box13_36).strip.length > 0)

	box13_1 = box2_4
	box13_43 = box2_6
	box13_2 = box2_1
else
	box13_1 = ''
	box13_43 = ''
	box13_2 = ''
end
print 'box13_1', box13_1
print 'box13_43', box13_43
print 'box13_2', box13_2
 
#
# Schedule U (Posting)
#

if ((box14_4 + box14_6 + box14_8 + box14_10 + box14_11 + box14_13  + box14_15 + box14_16 + box14_18 + box14_20 + box14_21 + box14_23 + box14_25 + box14_26 + box14_28).strip.length > 0)

	box14_1 = box2_4
	box14_2 = box2_6
	box14_3 = box2_1
else
	box14_1 = ''
	box14_2 = ''
	box14_3 = ''
end
print 'box14_1', box14_1
print 'box14_2', box14_2
print 'box14_3', box14_3

#
# Form RI-2210 page 1 & 2 (Posting)
#

if ((box15_53 + box15_54 + box15_3 + box15_5 + box15_7 + box15_9 + box15_10 + box15_13 + box16_41 + box16_42 + box16_44 + box16_45 + box16_47 + box16_48 + box16_52 + box16_1 + box16_9 + box16_18 + box16_27).strip.length > 0)
	box15_1 = ("#{box2_4} #{box2_5} #{box2_6} #{box2_72}" + (box2_7.strip.empty? ? '' : " & #{box2_7} #{box2_8} #{box2_9} #{box2_73}")).squeeze(' ').strip
	box15_2 = box2_1
	box16_36 = ("#{box2_4} #{box2_5} #{box2_6} #{box2_72}" + (box2_7.strip.empty? ? '' : " & #{box2_7} #{box2_8} #{box2_9} #{box2_73}")).squeeze(' ').strip
	box16_37 = box2_1
else
	box15_1 = ''
	box15_2 = ''
	box16_36 = ''
	box16_37 = ''
end
print 'box15_1', box15_1
print 'box15_2', box15_2
print 'box16_36', box16_36
print 'box16_37', box16_37

#
# Schedule W (Posting)
#

if ((box17_3 + box17_4 + box17_5 + box17_6 + box17_7 + box17_8 + box17_9 + box17_10 + box17_11 + box17_12 + box17_17 + box17_22 + box17_27 + box17_32 + box17_37 + box17_42 + box17_47 + box17_52 + box17_57 + box17_62 + box17_67 + box17_72 + box17_77).strip.length > 0)
	box17_1 = box2_4
	box17_113 = box2_6
	box17_2 = box2_1
else
	box17_1 = ''
	box17_113 = ''
	box17_2 = ''
end
print 'box17_1', box17_1
print 'box17_113', box17_113
print 'box17_2', box17_2

#
# Schedule E (Posting)
#

if (box18_114 + box18_115 + box18_116 + box18_117 + box18_118 + box18_119 + box18_120 + box18_121 + box18_122 + box18_123 + box18_124 + box18_125 + box18_126 + box18_127 + box18_128 + box18_129 + box18_130 + box18_131 + box18_132 + box18_133 + box18_134 + box18_135 + box18_136 + box18_137 + box18_138 + box18_139 + box18_140 + box18_141 + box18_142 + box18_143 + box18_144 + box18_145 + box18_146 + box18_147 + box18_148 + box18_149 + box18_150 + box18_151 + box18_152 + box18_153 + box18_154 + box18_155 + box18_156 + box18_157 + box18_158 + box18_159 + box18_160 + box18_161 + box18_162 + box18_163 + box18_164 + box18_165 + box18_166 + box18_167 + box18_169 + box18_170 + box18_171).strip.length > 0
	box18_1 = box2_4
	box18_113 = box2_6
	box18_2 = box2_1
else
	box18_1 = ''
	box18_113 = ''
	box18_2 = ''
end
print 'box18_1', box18_1
print 'box18_113', box18_113
print 'box18_2', box18_2

# ################  1D Barcode  #####################

#-###################################################################
# 
# CID
#
#CALC:
#Barcode values:
#Pg2: 181004 + CID + 0101
#Pg3: 181004 + CID + 0102
#Pg4: 181004 + CID + 0103
#Pg5: 181005 + CID + 0101
#Pg7: 181006 + CID + 0101
#Pg8: 181006 + CID + 0102
#Pg9: 181009 + CID + 0101
#Pg10: 181009 + CID + 0102
#Pg12: 181008 + CID + 0101
#Pg13: 181007 + CID + 0101
#Pg14: 181016 + CID + 0101
#Pg15: 181012 + CID + 0101
#Pg17: 181010 + CID + 0101
#Pg18: 181059 + CID + 0101
#2D: See spec pgs 16-23

#Note 12/13/18 [rtroy]:This year variable is used in both the 1D and 2D barcodes.
yr = '18'

box2_58 = ("#{yr}1004#{cid1_1}0101")
print 'box2_58', box2_58

box2_59 = box2_58
print 'box2_59', box2_59

box3_72 = ("#{yr}1004#{cid1_1}0102")
print 'box3_72', box3_72

box3_73 = box3_72
print 'box3_73', box3_73

box4_72 = ("#{yr}1004#{cid1_1}0103")
print 'box4_72', box4_72

box4_73 = box4_72
print 'box4_73', box4_73

box5_36 = ("#{yr}1005#{cid1_1}0101")
print 'box5_36', box5_36

box5_37 = box5_36
print 'box5_37', box5_37

box7_63 = ("#{yr}1006#{cid1_1}0101")
print 'box7_63', box7_63

box7_64 = box7_63
print 'box7_64', box7_64

box8_22 = ("#{yr}1006#{cid1_1}0102")
print 'box8_22', box8_22

box8_23 = box8_22
print 'box8_23', box8_23

box9_40 = ("#{yr}1009#{cid1_1}0101")
print 'box9_40', box9_40

box9_41 = box9_40
print 'box9_41', box9_41

box10_45 = ("#{yr}1009#{cid1_1}0102")
print 'box10_45', box10_45

box10_46 = box10_45
print 'box10_46', box10_46

box12_20 = ("#{yr}1008#{cid1_1}0101")
print 'box12_20', box12_20

box12_21 = box12_20
print 'box12_21', box12_21

box13_41 = ("#{yr}1007#{cid1_1}0101")
print 'box13_41', box13_41

box13_42 = box13_41
print 'box13_42', box13_42

box14_32 = ("#{yr}1016#{cid1_1}0101")
print 'box14_32', box14_32

box14_33 = box14_32
print 'box14_33', box14_33

box15_50 = ("#{yr}1012#{cid1_1}0101")
print 'box15_50', box15_50

box15_51 = box15_50
print 'box15_51', box15_51

box17_111 = ("#{yr}1010#{cid1_1}0101")
print 'box17_111', box17_111

box17_112 = box17_111
print 'box17_112', box17_112

box18_173 = ("#{yr}1059#{cid1_1}0101")
print 'box18_173', box18_173

box18_174 = box18_173
print 'box18_174', box18_174

# ################  2D Barcode  ######################

#Note 02/12/18 [rtroy]:Monetary fields cannot have decimal points in the 2D. Fields
#that are allocation percentages do need to include the decimal point. 

#Also, Jx wanted the state box on Shed. III part II line 22 to indicate "MU" if user paid 
#tax in more than one state, otherwise user should fill in state abbreviation. Determined 
#w/analyst that we can't do anything with this field w/out turning it into a green calc. field.
#The decision was made that the user will need to fill in this field with the state or the MU.

box2_60 = "T1\r#{cid1_1}\r0001\r20#{yr}\rRI1040N\r" <<
#
# Demographic Information
#
#Note 02/13/18 [rtroy]:Per the analyst allow spaces in the name and address even
#though specs. indicates alpha/numeric.
box2_4.delete("^A-Z0-9 ")[0,14] << "\r" <<
box2_5.delete("^A-Z0-9")[0,1] << "\r" <<
box2_6.delete("^A-Z0-9 ")[0,20] << "\r" <<
box2_72.delete("^A-Z0-9")[0,3] << "\r" <<
box2_1.delete("^0-9") << "\r" <<
box2_7.delete("^A-Z0-9 ")[0,14] << "\r" <<
box2_8.delete("^A-Z0-9")[0,1] << "\r" <<
box2_9.delete("^A-Z0-9 ")[0,20] << "\r" <<
box2_73.delete("^A-Z0-9")[0,3] << "\r" <<
box2_2.delete("^0-9") << "\r" <<
box2_10.delete("^A-Z0-9 ")[0,35] << "\r" <<
box2_11.delete("^A-Z0-9 ")[0,21] << "\r" <<
box2_12.delete("^A-Z0-9")[0,2] << "\r" <<
( box2_13.delete(' -') )[0,9] << "\r" <<
box2_14.delete("^A-Z0-9 ")[0,21] << "\r" <<
( box2_62.empty? ? '0' : '1' ) << "\r" <<
( box2_63.empty? ? '0' : '1' ) << "\r" <<
( box2_64.empty? ? '0' : '1' ) << "\r" <<
( box2_74.empty? ? '0' : '1' ) << "\r" <<
( box2_15.empty? ? '0' : '1' ) << "\r" <<
( box2_16.empty? ? '0' : '1' ) << "\r" <<
box2_17.delete("^CDFNR")[0,12] << "\r" <<
( box2_18.empty? ? '0' : '1' ) << "\r" <<
( box2_19.empty? ? '0' : '1' ) << "\r" <<
( box2_20.empty? ? '0' : '1' ) << "\r" <<
( box2_21.empty? ? '0' : '1' ) << "\r" <<
( box2_22.empty? ? '0' : '1' ) << "\r" <<
#
# RI-1040NR Information
#
#
box2_23.delete('.') << "\r" <<
box2_24.delete('.') << "\r" <<
box2_26.delete('.') << "\r" <<
box2_25.delete('.') << "\r" <<
box2_29.delete('.') << "\r" <<
box2_28[0,2] << "\r" <<
box2_32.delete('.') << "\r" <<
( box2_34.empty? ? '0' : '1' ) << "\r" <<
( box2_35.empty? ? '0' : '1' ) << "\r" <<
( box2_36.empty? ? '0' : '1' ) << "\r" <<
box2_38.delete('.') << "\r" <<
box2_40.delete('.') << "\r" <<
box2_41.delete('.') << "\r" <<
box2_42.delete('.') << "\r" <<
( box2_65.empty? ? '0' : '1' ) << "\r" <<
box3_74.delete('.') << "\r" <<
box3_75.delete('.') << "\r" <<
box3_76.delete('.') << "\r" <<
box3_77.delete('.') << "\r" <<
box3_78.delete('.') << "\r" <<
box3_79.delete('.') << "\r" <<
box3_87.delete('.') << "\r" <<
box3_81.delete('.') << "\r" <<
box3_82.delete('.') << "\r" <<
box3_84.delete('.') << "\r" <<
box3_85.delete('.') << "\r" <<
( box3_55.empty? ? '0' : '1' ) << "\r" <<
#Note 12/19/17 [rtroy]:There is one PTIN box validated for a PTIN or FEIN.
#If the preparer only uses an SSN they will have to override the field.
box3_59.delete("^P0-9")[0,9] << "\r" <<
box3_89.delete("^A-Z0-9")[0,10] << "\r" <<
box3_90.delete("^A-Z")[0,2] << "\r" <<
box3_91.delete("^A-Z0-9")[0,10] << "\r" <<
box3_92.delete("^A-Z")[0,2] << "\r" <<
#
# RI Schedule I
#
box4_2.delete('.') << "\r" << 
"\r" * 3 <<
#
# Checkoff Contribution Schedule
#
box4_10.delete('.') << "\r" <<
box4_12.delete('.') << "\r" <<
box4_18.delete('.') << "\r" <<
box4_24.delete('.') << "\r" <<
box4_30.delete('.') << "\r" <<
box4_36.delete('.') << "\r" <<
box4_42.delete('.') << "\r" <<
box4_43.delete('.') << "\r" <<
#
# RI Schedule EIC
#
box4_45.delete('.') << "\r" <<
#
# RI-1040H Property Tax Relief
#
"\r" * 14 <<
#
# RI-6238 
#
"\r" <<
#
# Schedule II
#
box5_9.delete('.') << "\r" <<
box5_10.delete('.') << "\r" <<
box5_11.delete('.') << "\r" <<
box5_12.delete('.') << "\r" <<
box5_13.delete('.') << "\r" <<
box5_14.delete('.') << "\r" <<
box5_15.delete('.') << "\r" <<
box5_16.delete('.') << "\r" <<
box5_17.delete('.') << "\r" <<
box5_18.delete('.') << "\r" <<
box5_19.delete('.') << "\r" <<
box5_20.delete('.') << "\r" <<
box5_21.delete('.') << "\r" <<
box5_22.delete('.') << "\r" <<
box5_25.delete('.') << "\r" <<
box5_26.delete('.') << "\r" <<
box5_29.delete('.') << "\r" <<
box5_30.delete('.') << "\r" <<
box5_33 << "\r" <<
box5_34.delete('.') << "\r" <<
box5_35.delete('.') << "\r" <<
#
# Schedule III
#
#Note 12/19/17 [rtroy]:Dates validated MM/DD/YYYY.
box7_9.delete("^0-9") << "\r" <<
box7_10.delete("^0-9") << "\r" <<
box7_11.delete('.') << "\r" <<
box7_12.delete('.') << "\r" <<
box7_14.delete('.') << "\r" <<
box7_15.delete('.') << "\r" <<
box7_16.delete('.') << "\r" <<
box7_18.delete('.') << "\r" <<
box7_19.delete('.') << "\r" <<
box7_20.delete('.') << "\r" <<
box7_22.delete('.') << "\r" <<
box7_23.delete('.') << "\r" <<
box7_24.delete('.')<< "\r" <<
box7_26.delete('.') << "\r" <<
box7_27.delete('.') << "\r" <<
box7_28.delete('.') << "\r" <<
box7_30.delete('.') << "\r" <<
box7_31.delete('.') << "\r" <<
box7_32.delete('.') << "\r" <<
box7_34.delete('.') << "\r" <<
box7_35.delete('.') << "\r" <<
box7_36.delete('.') << "\r" <<
box7_38.delete('.') << "\r" <<
box7_43.delete('.') << "\r" <<
box7_44.delete('.') << "\r" <<
box7_46.delete('.') << "\r" <<
box7_51.delete('.') << "\r" <<
box7_52.delete('.') << "\r" <<
box7_54.delete('.') << "\r" <<
box7_60 << "\r" <<
box7_61.delete('.') << "\r" <<
box7_62.delete('.') << "\r" <<
box8_10.delete('.') << "\r" <<
box8_14[0,2] << "\r" <<
box8_15.delete('.') << "\r" <<
box8_17.delete('.') << "\r" <<
#
# Schedule M (Page 1)
#
box9_18.delete('.') << "\r" <<
box9_19.delete('.') << "\r" <<
box9_20.delete('.') << "\r" <<
box9_21.delete('.') << "\r" <<
box9_22.delete('.') << "\r" <<
box9_23.delete('.') << "\r" <<
box9_24.delete('.') << "\r" <<
box9_25.delete('.') << "\r" <<
box9_26.delete('.') << "\r" <<
box9_27.delete('.') << "\r" <<
box9_28.delete('.') << "\r" <<
box9_29.delete('.') << "\r" <<
box9_30.delete('.') << "\r" <<
box9_31.delete('.') << "\r" <<
box9_32.delete('.') << "\r" <<
box9_33.delete('.') << "\r" <<
box9_34.delete('.') << "\r" <<
box9_35.delete('.') << "\r" <<
box9_36.delete('.') << "\r" <<
box9_37.delete('.') << "\r" <<
#Note 12/19/17 [rtroy]:DOB validated MM/DD/YYYY.
box9_42.delete("^0-9") << "\r" <<
box9_43.delete("^0-9") << "\r" <<
box9_44.delete('.') << "\r" <<
box9_45.delete("^0-9") << "\r" <<
box9_46.delete("^0-9") << "\r" <<
box9_38.delete('.') << "\r" <<
#
# Schedule M (Page 2)
#
box10_9.delete('.') << "\r" <<
box10_10.delete('.') << "\r" <<
box10_11.delete('.') << "\r" <<
box10_12.delete('.') << "\r" <<
box10_14.delete('.') << "\r" <<
box10_15.delete('.') << "\r" <<
box10_16.delete('.') << "\r" <<
"\r" * 4 <<
#
# Schedule CR
#
box12_25.delete('.') << "\r" <<
box12_9.delete('.') << "\r" <<
box12_10.delete('.') << "\r" <<
box12_22.delete('.') << "\r" <<
box12_23.delete('.') << "\r" <<
box12_11.delete('.') << "\r" <<
box12_24.delete('.') << "\r" <<
box12_12.delete('.') << "\r" <<
box12_13.delete("^A-Z0-9")[0,10] << "\r" <<
box12_14.delete("^A-Z0-9")[0,10] << "\r" <<
box12_15.delete('.') << "\r" <<
box12_16.delete("^A-Z0-9")[0,10] << "\r" <<
box12_17.delete("^A-Z0-9")[0,10] << "\r" <<
box12_18.delete('.') << "\r" <<
"\r" * 2 <<
#
# Schedule MU
#
"\r" * 13 <<
#
# Schedule NR-MU
#
box13_5.delete('.') << "\r" <<
box13_9.delete("^A-Z0-9")[0,2] << "\r" <<
box13_10.delete('.') << "\r" <<
box13_12.delete('.') << "\r" <<
box13_17.delete('.') << "\r" <<
box13_21.delete("^A-Z0-9")[0,2] << "\r" <<
box13_22.delete('.') << "\r" <<
box13_24.delete('.') << "\r" <<
box13_29.delete('.') << "\r" <<
box13_33.delete("^A-Z0-9")[0,2] << "\r" <<
box13_34.delete('.') << "\r" <<
box13_36.delete('.') << "\r" <<
box13_40.delete('.') << "\r" <<
#
# Schedule U
#
box14_7.delete('.') << "\r" <<
box14_9.delete('.') << "\r" <<
box14_31.delete('.') << "\r" <<
#
# RI-2210
#
( box15_53.empty? ? '0' : '1' ) << "\r" <<
( box15_54.empty? ? '0' : '1' ) << "\r" <<
#
# Schedule W
#
#Row 1
( box17_3.strip.empty? ? '0' : '1' ) << "\r" <<
#Note 12/09/16 [rtroy]:A bunch acceptable letters in the 2D but no validation. The best 
#we can do is restrict to alpha.
( box17_4.empty? ? '' : box17_4.delete("^A-Z")[0,1] ) << "\r" <<
box17_6.delete('-') << "\r" <<
box17_7.delete('.') << "\r" <<
#Row 2
( box17_8.strip.empty? ? '0' : '1' ) << "\r" <<
( box17_9.empty? ? '' : box17_9.delete("^A-Z")[0,1] ) << "\r" <<
box17_11.delete('-') << "\r" <<
box17_12.delete('.') << "\r" <<
#Row 3
( box17_13.strip.empty? ? '0' : '1' ) << "\r" <<
( box17_14.empty? ? '' : box17_14.delete("^A-Z")[0,1] ) << "\r" <<
box17_16.delete('-') << "\r" <<
box17_17.delete('.') << "\r" <<
#Row 4
( box17_18.strip.strip.empty? ? '0' : '1' ) << "\r" <<
( box17_19.empty? ? '' : box17_19.delete("^A-Z")[0,1] ) << "\r" <<
box17_21.delete('-') << "\r" <<
box17_22.delete('.') << "\r" <<
#Row 5
( box17_23.strip.strip.empty? ? '0' : '1' ) << "\r" <<
( box17_24.empty? ? '' : box17_24.delete("^A-Z")[0,1] ) << "\r" <<
box17_26.delete('-') << "\r" <<
box17_27.delete('.') << "\r" <<
#Row 6
( box17_28.strip.strip.empty? ? '0' : '1' ) << "\r" <<
( box17_29.empty? ? '' : box17_29.delete("^A-Z")[0,1] ) << "\r" <<
box17_31.delete('-') << "\r" <<
box17_32.delete('.') << "\r" <<
#Row 7
( box17_33.strip.strip.empty? ? '0' : '1' ) << "\r" <<
( box17_34.empty? ? '' : box17_34.delete("^A-Z")[0,1] ) << "\r" <<
box17_36.delete('-') << "\r" <<
box17_37.delete('.') << "\r" <<
#Row 8
( box17_38.strip.strip.empty? ? '0' : '1' ) << "\r" <<
( box17_39.empty? ? '' : box17_39.delete("^A-Z")[0,1] ) << "\r" <<
box17_41.delete('-') << "\r" <<
box17_42.delete('.') << "\r" <<
#Row 9
( box17_43.strip.strip.empty? ? '0' : '1' ) << "\r" <<
( box17_44.empty? ? '' : box17_44.delete("^A-Z")[0,1] ) << "\r" <<
box17_46.delete('-') << "\r" <<
box17_47.delete('.') << "\r" <<
#Row 10
( box17_48.strip.strip.empty? ? '0' : '1' ) << "\r" <<
( box17_49.empty? ? '' : box17_49.delete("^A-Z")[0,1] ) << "\r" <<
box17_51.delete('-') << "\r" <<
box17_52.delete('.') << "\r" <<
#Row 11
( box17_53.strip.strip.empty? ? '0' : '1' ) << "\r" <<
( box17_54.empty? ? '' : box17_54.delete("^A-Z")[0,1] ) << "\r" <<
box17_56.delete('-') << "\r" <<
box17_57.delete('.') << "\r" <<
#Row 12
( box17_58.strip.strip.empty? ? '0' : '1' ) << "\r" <<
( box17_59.empty? ? '' : box17_59.delete("^A-Z")[0,1] ) << "\r" <<
box17_61.delete('-') << "\r" <<
box17_62.delete('.') << "\r" <<
#Row 13
( box17_63.strip.strip.empty? ? '0' : '1' ) << "\r" <<
( box17_64.empty? ? '' : box17_64.delete("^A-Z")[0,1] ) << "\r" <<
box17_66.delete('-') << "\r" <<
box17_67.delete('.') << "\r" <<
#Row 14
( box17_68.strip.strip.empty? ? '0' : '1' ) << "\r" <<
( box17_69.empty? ? '' : box17_69.delete("^A-Z")[0,1] ) << "\r" <<
box17_71.delete('-') << "\r" <<
box17_72.delete('.') << "\r" <<
#Row 15
( box17_73.strip.strip.empty? ? '0' : '1' ) << "\r" <<
( box17_74.empty? ? '' : box17_74.delete("^A-Z")[0,1] ) << "\r" <<
box17_76.delete('-') << "\r" <<
box17_77.delete('.') << "\r" <<
box17_104 << "\r" << 
#
#Schedule E
#
( box18_114.strip.empty? ? '0' : '1' ) << "\r" <<
( box18_115.strip.empty? ? '0' : '1' ) << "\r" <<
#Row 2a
box18_116[0,40] << "\r" <<
box18_117.delete("^0-9") << "\r" <<
box18_118.delete("^0-9") << "\r" <<
box18_119[0,12] << "\r" <<
#Row 2b
box18_120[0,40] << "\r" <<
box18_121.delete("^0-9") << "\r" <<
box18_122.delete("^0-9") << "\r" <<
box18_123[0,12] << "\r" <<
#Row 2c
box18_124[0,40] << "\r" <<
box18_125.delete("^0-9") << "\r" <<
box18_126.delete("^0-9") << "\r" <<
box18_127[0,12] << "\r" <<
#Row 2d
box18_128[0,40] << "\r" <<
box18_129.delete("^0-9") << "\r" <<
box18_130.delete("^0-9") << "\r" <<
box18_131[0,12] << "\r" <<
#Row 2e
box18_132[0,40] << "\r" <<
box18_133.delete("^0-9") << "\r" <<
box18_134.delete("^0-9") << "\r" <<
box18_135[0,12] << "\r" <<
#Row 2f
box18_136[0,40] << "\r" <<
box18_137.delete("^0-9") << "\r" <<
box18_138.delete("^0-9") << "\r" <<
box18_139[0,12] << "\r" <<
#Row 2g
box18_140[0,40] << "\r" <<
box18_141.delete("^0-9") << "\r" <<
box18_142.delete("^0-9") << "\r" <<
box18_143[0,12] << "\r" <<
#Row 2h
box18_144[0,40] << "\r" <<
box18_145.delete("^0-9") << "\r" <<
box18_146.delete("^0-9") << "\r" <<
box18_147[0,12] << "\r" <<
#Row 2i
box18_148[0,40] << "\r" <<
box18_149.delete("^0-9") << "\r" <<
box18_150.delete("^0-9") << "\r" <<
box18_151[0,12] << "\r" <<
#Row 2j
box18_152[0,40] << "\r" <<
box18_153.delete("^0-9") << "\r" <<
box18_154.delete("^0-9") << "\r" <<
box18_155[0,12] << "\r" <<
#Row 2k
box18_156[0,40] << "\r" <<
box18_157.delete("^0-9") << "\r" <<
box18_158.delete("^0-9") << "\r" <<
box18_159[0,12] << "\r" <<
#Row 2l
box18_160[0,40] << "\r" <<
box18_161.delete("^0-9") << "\r" <<
box18_162.delete("^0-9") << "\r" <<
box18_163[0,12] << "\r" <<
#Row 2m
box18_164[0,40] << "\r" <<
box18_165.delete("^0-9") << "\r" <<
box18_166.delete("^0-9") << "\r" <<
box18_167[0,12] << "\r" << 
"*EOD*\r"
print 'box2_60', box2_60
